## libnfc 1.7.0

=== CMakeLists.txt ===
PROJECT(libnfc C)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
SET(VERSION_MAJOR "1")
SET(VERSION_MINOR "7")
SET(VERSION_PATCH "0")

SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

SET(PACKAGE_NAME "libnfc")
SET(PACKAGE_VERSION ${VERSION})
SET(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")

# config.h
IF(WIN32)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config_windows.h.cmake ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
  SET(LIBNFC_SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/config" CACHE PATH "libnfc configuration directory")
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/contrib/win32)
ELSE(WIN32)
  SET(_XOPEN_SOURCE 600)
  SET(SYSCONFDIR "/etc" CACHE PATH "System configuration directory")
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config_posix.h.cmake ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
ENDIF(WIN32)

ADD_DEFINITIONS("-DHAVE_CONFIG_H")

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/include)

# make it easy to locate CMake modules for finding libraries
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# Options
SET(LIBNFC_LOG ON CACHE BOOL "Enable log facility (errors, warning, info and debug messages)")
IF(LIBNFC_LOG)
  ADD_DEFINITIONS(-DLOG)
ENDIF(LIBNFC_LOG)

SET(LIBNFC_ENVVARS ON CACHE BOOL "Enable envvars facility")
IF(LIBNFC_ENVVARS)
  ADD_DEFINITIONS(-DENVVARS)
ENDIF(LIBNFC_ENVVARS)

SET(LIBNFC_DEBUG_MODE OFF CACHE BOOL "Debug mode")
IF(LIBNFC_DEBUG_MODE)
  ADD_DEFINITIONS(-DDEBUG)
  SET(CMAKE_C_FLAGS "-g3 ${CMAKE_C_FLAGS}")
  SET(WIN32_MODE "debug")
  SET(CMAKE_RC_FLAGS "-D_DEBUG ${CMAKE_RC_FLAGS}")
ELSE(LIBNFC_DEBUG_MODE)
  SET(WIN32_MODE "release")
ENDIF(LIBNFC_DEBUG_MODE)

# Doxygen
SET(builddir "${CMAKE_BINARY_DIR}")
SET(top_srcdir "${CMAKE_SOURCE_DIR}")
INCLUDE(UseDoxygen)

IF(DEFINED CMAKE_INSTALL_LIBDIR)
  SET(libdir ${CMAKE_INSTALL_LIBDIR})
ELSE(DEFINED CMAKE_INSTALL_LIBDIR)
  SET(CMAKE_INSTALL_LIBDIR lib)
  SET(libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
ENDIF(DEFINED CMAKE_INSTALL_LIBDIR)

IF(DEFINED INCLUDE_INSTALL_DIR)
  SET(includedir ${INCLUDE_INSTALL_DIR})
ELSE(DEFINED INCLUDE_INSTALL_DIR)
  SET(INCLUDE_INSTALL_DIR include)
  SET(includedir ${CMAKE_INSTALL_PREFIX}/${INCLUDE_INSTALL_DIR})
ENDIF(DEFINED INCLUDE_INSTALL_DIR)

IF(NOT DEFINED SHARE_INSTALL_PREFIX)
  SET(SHARE_INSTALL_PREFIX share)
ENDIF(NOT DEFINED SHARE_INSTALL_PREFIX)

# Additonnal GCC flags
IF(CMAKE_COMPILER_IS_GNUCC)
  # Make sure we will not miss some warnings ;)
  SET(CMAKE_C_FLAGS "-Wall -pedantic -std=c99 ${CMAKE_C_FLAGS}")
ENDIF(CMAKE_COMPILER_IS_GNUCC)

# Workarounds for libusb in C99
ADD_DEFINITIONS(-Du_int8_t=uint8_t -Du_int16_t=uint16_t)

IF(MINGW)
  # force MinGW-w64 in 32bit mode
  SET(CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}")
  SET(CMAKE_MODULE_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_SHARED_LINKER_FLAGS}")
  SET(CMAKE_SHARED_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_SHARED_LINKER_FLAGS}")
  SET(CMAKE_EXE_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_EXE_LINKER_FLAGS}")
  SET(CMAKE_RC_FLAGS "--target=pe-i386 --output-format=coff ${CMAKE_RC_FLAGS}")
ENDIF(MINGW)

IF(NOT WIN32)
  # Set some pkg-config variables
  SET(prefix ${CMAKE_INSTALL_PREFIX})
  SET(exec_prefix ${CMAKE_INSTALL_PREFIX})
  SET(PACKAGE "libnfc")
  IF(LIBNFC_DRIVER_PN53X_USB)
    SET(PKG_REQ ${PKG_REQ} "libusb")
  ENDIF(LIBNFC_DRIVER_PN53X_USB)
  IF(LIBNFC_DRIVER_ACR122)
    SET(PKG_REQ ${PKG_REQ} "libpcsclite")
  ENDIF(LIBNFC_DRIVER_ACR122)
  # CMake lists are separated by a semi colon, replace with colon
  STRING(REPLACE ";" "," PKG_CONFIG_REQUIRES "${PKG_REQ}")
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libnfc.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libnfc.pc @ONLY) 
  INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libnfc.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
ENDIF(NOT WIN32)

# Require PCRE for Win32
IF (WIN32)
  FIND_PACKAGE(PCRE REQUIRED)
  IF(PCRE_INCLUDE_DIRS)
    INCLUDE_DIRECTORIES(${PCRE_INCLUDE_DIRS})
    LINK_DIRECTORIES(${PCRE_LIBRARY_DIRS})
  ENDIF(PCRE_INCLUDE_DIRS)
ENDIF(WIN32)

INCLUDE(LibnfcDrivers)

IF(PCSC_INCLUDE_DIRS)
  INCLUDE_DIRECTORIES(${PCSC_INCLUDE_DIRS})
  LINK_DIRECTORIES(${PCSC_LIBRARY_DIRS})
ENDIF(PCSC_INCLUDE_DIRS)

IF(LIBUSB_INCLUDE_DIRS)
  INCLUDE_DIRECTORIES(${LIBUSB_INCLUDE_DIRS})
  LINK_DIRECTORIES(${LIBUSB_LIBRARY_DIRS})
  SET(LIBUSB_FOUND TRUE)
ENDIF(LIBUSB_INCLUDE_DIRS)

# version.rc for Windows
IF(WIN32)
  # Date for filling in rc file information
  MACRO (GET_CURRENT_YEAR RESULT)
    EXECUTE_PROCESS(COMMAND "cmd" " /C date /T" OUTPUT_VARIABLE ${RESULT})
    STRING(REGEX REPLACE ".*(..)/(..)/(....).*" "\\3" ${RESULT} ${${RESULT}})
  ENDMACRO (GET_CURRENT_YEAR)
  GET_CURRENT_YEAR(CURRENT_YEAR)
  MESSAGE("Year for copyright is " ${CURRENT_YEAR})

  SET(RC_COMMENT "${PACKAGE_NAME} library")
  SET(RC_INTERNAL_NAME "${PACKAGE_NAME} ${WIN32_MODE}")
  SET(RC_ORIGINAL_NAME ${PACKAGE_NAME}.dll)
  SET(RC_FILE_TYPE VFT_DLL)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/contrib/win32/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/windows/libnfc.rc @ONLY)
ENDIF(WIN32)

ADD_SUBDIRECTORY(libnfc)
ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(utils)
ADD_SUBDIRECTORY(examples)

# Binary Package
IF(WIN32)
  SET(CPACK_GENERATOR "ZIP")
ELSE(WIN32)
  SET(CPACK_GENERATOR "TBZ2")
ENDIF(WIN32)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Near Field Communication (NFC) library")
SET(CPACK_PACKAGE_VENDOR "Roel Verdult")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "libnfc")
SET(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
SET(CPACK_COMPONENT_LIBRARIES_DISPLAY_NAME "NFC Library")
SET(CPACK_COMPONENT_EXAMPLES_DISPLAY_NAME "Example Applications")
SET(CPACK_COMPONENT_HEADERS_DISPLAY_NAME "Development Headers")
IF(NOT WIN32)
  SET(CPACK_COMPONENT_MANUALS_DISPLAY_NAME "Example Applications Manuals")
  SET(CPACK_COMPONENT_MANUALS_DISABLED TRUE)
  SET(CPACK_COMPONENT_MANUALS_DEPENDS examples)
ENDIF(NOT WIN32)
SET(CPACK_COMPONENT_HEADERS_DISABLED TRUE)
SET(CPACK_COMPONENT_HEADERS_DEPENDS libraries)
SET(CPACK_COMPONENT_EXAMPLES_DEPENDS libraries)

# Source Package
IF(WIN32)
  SET(CPACK_SOURCE_GENERATOR "ZIP")
ELSE(WIN32)
  SET(CPACK_SOURCE_GENERATOR "ZIP;TBZ2")
ENDIF(WIN32)

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "libnfc-${VERSION}")
SET(CPACK_SOURCE_IGNORE_FILES "~$" "/\\\\.git/" "bin/")
INCLUDE(CPack)

=== libnfc/CMakeLists.txt ===
# Windows MinGW workarounds
IF(WIN32)
  SET(WINDOWS_SOURCES ../contrib/win32/stdlib)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32)

  # Add in the rc for version information in the dll
  LIST(APPEND WINDOWS_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/../windows/libnfc.rc)
ENDIF(WIN32)

# Library's chips
SET(CHIPS_SOURCES chips/pn53x)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/chips)

# Library's buses
IF(USB_REQUIRED)
  LIST(APPEND BUSES_SOURCES buses/usbbus)
ENDIF(USB_REQUIRED)

IF(UART_REQUIRED)
  IF(WIN32)
    # Windows have a special implementation for UART
    LIST(APPEND BUSES_SOURCES ../contrib/win32/libnfc/buses/uart)
  ELSE(WIN32)
    LIST(APPEND BUSES_SOURCES buses/uart)
  ENDIF(WIN32)
ENDIF(UART_REQUIRED)

IF(I2C_REQUIRED)
  IF(WIN32)
    # Windows is not supported at the moment
    #LIST(APPEND BUSES_SOURCES ../contrib/win32/libnfc/buses/i2c)
    MESSAGE( FATAL_ERROR "I2C not (yet) supported under Windows!" )
  ELSE(WIN32)
    LIST(APPEND BUSES_SOURCES buses/i2c)
  ENDIF(WIN32)
ENDIF(I2C_REQUIRED)

IF(SPI_REQUIRED)
  IF(WIN32)
    # Windows is not supported at the moment
    #LIST(APPEND BUSES_SOURCES ../contrib/win32/libnfc/buses/spi)
    MESSAGE( FATAL_ERROR "SPI not (yet) supported under Windows!" )
  ELSE(WIN32)
    LIST(APPEND BUSES_SOURCES buses/spi)
  ENDIF(WIN32)
ENDIF(SPI_REQUIRED)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/buses)

IF(WIN32)
  # Windows now requires regex, so we utilize PCRE
  # since Windows doesn't get the benefit of finding in CMake
  # it has to be added manually
  IF(PCRE_FOUND)
    INCLUDE_DIRECTORIES(${PCRE_INCLUDE_DIRS})
    LINK_DIRECTORIES(${PCRE_LIBRARY_DIRS})
  ENDIF(PCRE_FOUND)
ENDIF(WIN32)

IF(PCSC_FOUND)
  INCLUDE_DIRECTORIES(${PCSC_INCLUDE_DIRS})
  LINK_DIRECTORIES(${PCSC_LIBRARY_DIRS})
ENDIF(PCSC_FOUND)

IF(LIBUSB_FOUND)
  INCLUDE_DIRECTORIES(${LIBUSB_INCLUDE_DIRS})
  LINK_DIRECTORIES(${LIBUSB_LIBRARY_DIRS})
ENDIF(LIBUSB_FOUND)

# Library
SET(LIBRARY_SOURCES nfc nfc-device nfc-emulation nfc-internal conf iso14443-subr mirror-subr target-subr ${DRIVERS_SOURCES} ${BUSES_SOURCES} ${CHIPS_SOURCES} ${WINDOWS_SOURCES})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

IF(LIBNFC_LOG)
  IF(WIN32)
    SET(CMAKE_C_FLAGS "-fgnu89-inline ${CMAKE_C_FLAGS}")
    LIST(APPEND LIBRARY_SOURCES log ../contrib/win32/libnfc/log-internal)
  ELSE(WIN32)
    LIST(APPEND LIBRARY_SOURCES log log-internal)
  ENDIF(WIN32)
ENDIF(LIBNFC_LOG)
ADD_LIBRARY(nfc SHARED ${LIBRARY_SOURCES})

IF(PCSC_FOUND)
  TARGET_LINK_LIBRARIES(nfc ${PCSC_LIBRARIES})
ENDIF(PCSC_FOUND)

IF(LIBUSB_FOUND)
  TARGET_LINK_LIBRARIES(nfc ${LIBUSB_LIBRARIES})
ENDIF(LIBUSB_FOUND)

SET_TARGET_PROPERTIES(nfc PROPERTIES SOVERSION 0)

IF(WIN32)
  # Libraries that are windows specific
  TARGET_LINK_LIBRARIES(nfc wsock32)
  IF(PCRE_FOUND)
    TARGET_LINK_LIBRARIES(nfc ${PCRE_LIBRARIES})
  ENDIF(PCRE_FOUND)

  ADD_CUSTOM_COMMAND(
    OUTPUT libnfc.lib
    COMMAND dlltool -d ${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32/nfc.def -l ${CMAKE_CURRENT_BINARY_DIR}/libnfc.lib ${CMAKE_CURRENT_BINARY_DIR}/libnfc.dll
    DEPENDS nfc ${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32/nfc.def
  )
  ADD_CUSTOM_TARGET(win32lib ALL DEPENDS libnfc.lib)

  # On Windows the shared (runtime) library should be either in the same 
  # directory as the excutables or in the path, we add it to same directory
  INSTALL(TARGETS nfc RUNTIME DESTINATION bin COMPONENT libraries)

  # At compile time we need the .LIB file, we place it in the lib directory
  INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libnfc.lib DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries)
ELSE(WIN32)
  INSTALL(TARGETS nfc LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries)
ENDIF(WIN32)

=== utils/CMakeLists.txt ===
SET(UTILS-SOURCES 
  nfc-emulate-forum-tag4
  nfc-list
  nfc-mfclassic
  nfc-mfultralight
  nfc-read-forum-tag3
  nfc-relay-picc
  nfc-scan-device
)

ADD_LIBRARY(nfcutils STATIC 
  nfc-utils.c
)
TARGET_LINK_LIBRARIES(nfcutils nfc)

# Examples
FOREACH(source ${UTILS-SOURCES})
  SET (TARGETS ${source}.c)

  IF(WIN32)
    SET(RC_COMMENT "${PACKAGE_NAME} utility")
    SET(RC_INTERNAL_NAME ${source})
    SET(RC_ORIGINAL_NAME ${source}.exe)
    SET(RC_FILE_TYPE VFT_APP)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/../windows/${source}.rc @ONLY)
    LIST(APPEND TARGETS ${CMAKE_CURRENT_BINARY_DIR}/../windows/${source}.rc)
  ENDIF(WIN32)

  IF((${source} MATCHES "nfc-mfultralight") OR (${source} MATCHES "nfc-mfclassic"))
    LIST(APPEND TARGETS mifare)
  ENDIF((${source} MATCHES "nfc-mfultralight") OR (${source} MATCHES "nfc-mfclassic"))

  IF(WIN32)
    IF(${source} MATCHES "nfc-scan-device")
      LIST(APPEND TARGETS ../contrib/win32/stdlib)
      INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32)
    ENDIF(${source} MATCHES "nfc-scan-device")
  ENDIF(WIN32)

  ADD_EXECUTABLE(${source} ${TARGETS})

  TARGET_LINK_LIBRARIES(${source} nfc)
  TARGET_LINK_LIBRARIES(${source} nfcutils)

  INSTALL(TARGETS ${source} RUNTIME DESTINATION bin COMPONENT utils)
ENDFOREACH(source)

#install required libraries
IF(WIN32)
  INCLUDE(InstallRequiredSystemLibraries)
  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/cmake/FixBundle.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/FixBundle.cmake @ONLY)
  INSTALL(SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/FixBundle.cmake)
ENDIF(WIN32)

IF(NOT WIN32)
  # Manuals for the examples
  FILE(GLOB manuals "${CMAKE_CURRENT_SOURCE_DIR}/*.1")
  INSTALL(FILES ${manuals} DESTINATION ${SHARE_INSTALL_PREFIX}/man/man1 COMPONENT manuals)
ENDIF(NOT WIN32)

=== include/nfc/CMakeLists.txt ===
# Headers
FILE(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${headers} DESTINATION ${INCLUDE_INSTALL_DIR}/nfc COMPONENT headers)

=== debian/changelog ===
libnfc (1.7.0-3) unstable; urgency=low

  [ Ludovic Rousseau ]
  * update debian/watch: update the URL to make uscan work again

  [ Nobuhiro Iwamatsu ]
  * Install blacklist-libnfc.conf to etc/modprobe.d.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 05 Oct 2013 07:54:27 +0900

libnfc (1.7.0-2) unstable; urgency=low

  * Update debian/control.
    - Add Replaces and Breaks for libnfc4.
    - Update Vcs-Git and Vcs-Browser field.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 18 Sep 2013 13:55:20 +0900

libnfc (1.7.0-1) unstable; urgency=low
  
  * Upload to Debian. (Closes: #722066)
  * Add patches/0001-Add-support-kFreeBSD.patch.
    Fix build on kFreeBSD.
  * Update debian/control.
    Add Ludovic Rousseau to Uploaders.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 09 Sep 2013 13:10:26 +0900

libnfc (1.7.0-0) UNRELEASED; urgency=low

  * New upstream release

 -- yobibe <yobibe@gmail.com>  Fri, 3 Sep 2013 16:42:42 +0100

libnfc (1.7.0~rc7-1) unstable; urgency=low

  * Upload to Debian. (Closes: #672795)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 28 Aug 2013 12:49:12 +0900

libnfc (1.7.0~rc7-0) UNRELEASED; urgency=low

  * New upstream release

 -- yobibe <yobibe@gmail.com>  Fri, 5 Apr 2013 12:42:42 +0100

libnfc (1.7.0~rc6-0) UNRELEASED; urgency=low

  * New upstream release

 -- yobibe <yobibe@gmail.com>  Sun, 3 Mar 2013 12:42:42 +0100

libnfc (1.7.0~rc5-0) UNRELEASED; urgency=low

  * New upstream release

 -- Romuald Conty <romuald@libnfc.org>  Sat, 16 Feb 2013 15:42:42 +0100

libnfc (1.7.0~rc4-0) UNRELEASED; urgency=low

  * New upstream release

 -- yobibe <yobibe@gmail.com>  Wed, 6 Feb 2013 12:42:42 +0100

libnfc (1.7.0~rc2-0) UNRELEASED; urgency=low

  * New upstream release

 -- Romuald Conty <romuald@libnfc.org>  Sun, 20 Jan 2013 12:42:42 +0100

libnfc (1.7.0~rc1-0) UNRELEASED; urgency=low

  * New upstream release

 -- Romuald Conty <romuald@libnfc.org>  Thu, 9 Dec 2012 12:42:42 +0100

libnfc (1.6.0rc1-0) UNRELEASED; urgency=low

  * New upstream release

 -- Romuald Conty <romuald@libnfc.org>  Mon, 27 Feb 2012 12:42:42 +0100

libnfc (1.5.1pre2.1-0) UNRELEASED; urgency=low

  * udev rules file renamed accordingly to udev's readme file

 -- Romuald Conty <romuald@libnfc.org>  Fri, 9 Dec 2011 15:42:42 +0100

libnfc (1.5.1-0) UNRELEASED; urgency=low

  * Move nfc-emulate-nfcforum-tag2, nfc-emulate-nfcforum-tag4 and
     nfc-relay-picc from libnfc-examples to libnfc-bin package.
  * Add nfc-read-forum-tag3 to libnfc-bin package.

 -- Romuald Conty <romuald@libnfc.org>  Mon, 10 Oct 2011 02:42:42 +0100

libnfc (1.5.0pre1.4-0) UNRELEASED; urgency=low

  * All drivers are now enabled under Debian;
  * Add nfc-emulate-nfcforum-tag2 and nfc-mfsetuid to libnfc-examples.

 -- Romuald Conty <romuald@libnfc.org>  Tue, 13 May 2011 15:42:42 +0100

libnfc (1.5.0pre1.3-0) UNRELEASED; urgency=low

  * Update debian/copyright.

 -- Romuald Conty <romuald@libnfc.org>  Wed, 18 May 2011 12:42:42 +0100

libnfc (1.5.0pre1.2-0) UNRELEASED; urgency=low

  * Change name of lib to libnfc2 to match SONAME major version 2.

 -- Thomas Hood <jdthood@gmail.com>  Fri, 13 May 2011 12:00:00 +0100

libnfc (1.5.0pre1.1-0) UNRELEASED; urgency=low

  * Change name of lib to libnfc1 to match SONAME major version 1.
  * Change section and priority.
  * Don't depend on automake which doesn't get run on build.
    (Instead, automake-generated files are included in patches/.)
  * Set debian/source/format contents to "3.0 (quilt)"
  * chmod ugo+x ./configure in debian/rules.
  * Depend on debhelper (>= 7) to match debian/compat.
  * Make the following changes that were suggested by lintian.
  * Depend on ${misc:Depends} since we use debhelper.
  * Use dh_prep instead of dh_clean -k.

 -- Thomas Hood <jdthood@gmail.com>  Mon, 10 May 2011 12:00:00 +0100

libnfc (1.5.0-0) UNRELEASED; urgency=low

  * Experimental released version (r1019).

 -- Romuald Conty <romuald@libnfc.org>  Mon, 29 Apr 2011 11:42:42 +0100

libnfc (1.4.2-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Tue, 21 Feb 2011 11:42:42 +0100

libnfc (1.4.1-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Tue, 1 Feb 2011 10:42:42 +0100

libnfc (1.4.0-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Tue, 26 Oct 2010 16:42:42 +0100

libnfc (1.3.9-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Tue, 31 Aug 2010 14:42:42 +0100

libnfc (1.3.4-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Wed, 31 Mar 2010 12:42:42 +0100

libnfc (1.3.3-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Thu, 17 Feb 2010 15:42:42 +0100

libnfc (1.3.2-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Fri, 29 Jan 2010 15:42:42 +0100

libnfc (1.3.1-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Mon, 25 Jan 2010 11:42:42 +0100

libnfc (1.3.0-0) UNRELEASED; urgency=low

  * New upstream release.

 -- Romuald Conty <romuald@libnfc.org>  Thu, 14 Jan 2010 16:42:42 +0100

libnfc (1.2.1-4) UNRELEASED; urgency=low

  * Add udev rules for USB PN53x.

 -- Romuald Conty <romuald@libnfc.org>  Fri, 20 Nov 2009 16:42:42 +0100

libnfc (1.2.1-3) UNRELEASED; urgency=low

  * Don't use CDBS anymore, should now cross compile.

 -- Romuald Conty <romuald@libnfc.org>  Thu, 29 Sep 2009 9:42:42 +0100

libnfc (1.2.1-2) UNRELEASED; urgency=low

  * Add missing dependencies for ACR122 devices (pcscd).

 -- Romuald Conty <romuald@libnfc.org>  Fri, 23 Sep 2009 16:42:42 +0100

libnfc (1.2.1-1) UNRELEASED; urgency=low

  * Description have been updated.
  * Provided binairies should not be consider as tools but as examples.

 -- Romuald Conty <romuald@libnfc.org>  Fri, 03 Sep 2009 18:42:42 +0100



=== debian/control ===
Source: libnfc
Section: libs
Priority: extra
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Uploaders: Ludovic Rousseau <rousseau@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf, libtool, pkg-config, libusb-dev
Standards-Version: 3.9.4
Homepage: http://www.nfc-tools.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/libnfc.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libnfc.git;a=summary

Package: libnfc5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libnfc4
Breaks: libnfc4
Description: Near Field Communication (NFC) library
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 This package contains the runtime library files needed to run software
 using libnfc.

Package: libnfc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libnfc5 (= ${binary:Version}), libusb-dev
Description: Near Field Communication (NFC) library (development files)
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 This package contains the header and development files needed to build
 programs and packages using libnfc.

Package: libnfc5-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libnfc5 (= ${binary:Version})
Description: Near Field Communication (NFC) library (debugging information)
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 This package contains the debugging information.

Package: libnfc-bin
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libnfc5 (>= ${binary:Version})
Description: Near Field Communication (NFC) binaries
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 This package contains some utils that come along with libnfc, for
 development or debugging purposes (including nfc-list, nfc-mfclassic,
 nfc-mfultralight, etc).

Package: libnfc-examples
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libnfc5 (>= ${binary:Version})
Description: Near Field Communication (NFC) examples
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 Some examples are provided with libnfc for debugging and/or
 educational purposes (nfc-anticol, nfc-emulate, etc.).

Package: libnfc-pn53x-examples
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libnfc5 (>= ${binary:Version})
Description: Near Field Communication (NFC) examples for PN53x chips only
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 Some PN53x-only examples are provided with libnfc for debugging
 and/or educational purposes (pn53x-sam, pn53x-tamashell, etc.).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# "nocheck" option prevents from running tests (which need dedicated hardware)
export DEB_BUILD_OPTIONS=nocheck

# --enable-debug --with-drivers=all
confflags := --disable-silent-rules \
	--prefix=/usr \
	--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
	$(NULL)
confflags += $(shell dpkg-buildflags --export=configure)

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_auto_configure: 
	dh_auto_configure -- $(confflags)

%:
	dh $@ --with autoreconf

override_dh_strip:
	dh_strip -plibnfc5 --dbg-package=libnfc5-dbg
	dh_strip --remaining-packages

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

http://code.google.com/p/libnfc/downloads/list .*/libnfc-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## libnfc 1.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
 SET(VERSION_MAJOR "1")
 SET(VERSION_MINOR "7")
-SET(VERSION_PATCH "0")
+SET(VERSION_PATCH "1")
 
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
@@ -48,6 +48,11 @@
 ELSE(LIBNFC_DEBUG_MODE)
   SET(WIN32_MODE "release")
 ENDIF(LIBNFC_DEBUG_MODE)
+
+SET(LIBNFC_CONFFILES_MODE ON CACHE BOOL "Enable configuration files")
+IF(LIBNFC_CONFFILES_MODE)
+  ADD_DEFINITIONS(-DCONFFILES)
+ENDIF(LIBNFC_CONFFILES_MODE)
 
 # Doxygen
 SET(builddir "${CMAKE_BINARY_DIR}")
@@ -134,6 +139,7 @@
   # Date for filling in rc file information
   MACRO (GET_CURRENT_YEAR RESULT)
     EXECUTE_PROCESS(COMMAND "cmd" " /C date /T" OUTPUT_VARIABLE ${RESULT})
+    STRING(REGEX REPLACE "\n" "" ${RESULT} ${${RESULT}})
     STRING(REGEX REPLACE ".*(..)/(..)/(....).*" "\\3" ${RESULT} ${${RESULT}})
   ENDMACRO (GET_CURRENT_YEAR)
   GET_CURRENT_YEAR(CURRENT_YEAR)

=== examples/CMakeLists.txt ===
SET(EXAMPLES-SOURCES
  nfc-anticol
  nfc-dep-initiator
  nfc-dep-target
  nfc-emulate-forum-tag2
  nfc-emulate-tag
  nfc-emulate-uid
  nfc-mfsetuid
  nfc-poll
  nfc-relay
)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../libnfc)

# Examples
FOREACH(source ${EXAMPLES-SOURCES})
  SET (TARGETS ${source}.c)

  IF(WIN32)
    SET(RC_COMMENT "${PACKAGE_NAME} example")
    SET(RC_INTERNAL_NAME ${source})
    SET(RC_ORIGINAL_NAME ${source}.exe)
    SET(RC_FILE_TYPE VFT_APP)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/../windows/${source}.rc @ONLY)
    LIST(APPEND TARGETS ${CMAKE_CURRENT_BINARY_DIR}/../windows/${source}.rc)
  ENDIF(WIN32)

  ADD_EXECUTABLE(${source} ${TARGETS})
  TARGET_LINK_LIBRARIES(${source} nfc)
  TARGET_LINK_LIBRARIES(${source} nfcutils)
  INSTALL(TARGETS ${source} RUNTIME DESTINATION bin COMPONENT examples)
ENDFOREACH(source)

#install required libraries
IF(WIN32)
  INCLUDE(InstallRequiredSystemLibraries)
  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/cmake/FixBundle.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/FixBundle.cmake @ONLY)
  INSTALL(SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/FixBundle.cmake)
ENDIF(WIN32)

IF(NOT WIN32)
  # Manuals for the examples
  FILE(GLOB manuals "${CMAKE_CURRENT_SOURCE_DIR}/*.1")
  INSTALL(FILES ${manuals} DESTINATION ${SHARE_INSTALL_PREFIX}/man/man1 COMPONENT manuals)
ENDIF(NOT WIN32)

=== include/CMakeLists.txt ===
ADD_SUBDIRECTORY(nfc)

=== debian/changelog ===
libnfc (1.7.1-4) unstable; urgency=medium

  * Update debian/watch to track new upstream releases on github
    (the project moved away from code.google.com).
  * Update Source section in copyright file.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 08 Oct 2015 00:21:44 +0900

libnfc (1.7.1-3) unstable; urgency=medium

  * Install libnfc.conf to /etc/nfc. (Closes: #776225)
  * Bump Standards-Version to 3.9.6.
  * Update copytight.
    Fix lintian warning: dep5-copyright-license-name-not-unique.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 05 Jun 2015 09:01:42 +0900

libnfc (1.7.1-2) unstable; urgency=medium

  * Fix timeout message from ACR122U.
    Add patches/fix_timeout_message_with_ACR122U.patch. (Closes: #759355)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sun, 07 Sep 2014 03:14:23 +0900

libnfc (1.7.1-1) unstable; urgency=low

  * New upstream released.
  * Remove debian/patches.
  * Update debian/control.
    - Update Standards-Version to 3.9.5.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 05 Mar 2014 09:07:14 +0900

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
 Uploaders: Ludovic Rousseau <rousseau@debian.org>
 Build-Depends: debhelper (>= 9), dh-autoreconf, libtool, pkg-config, libusb-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://www.nfc-tools.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/libnfc.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libnfc.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -27,6 +27,11 @@
 override_dh_auto_configure: 
 	dh_auto_configure -- $(confflags)
 
+override_dh_auto_install:
+	dh_auto_install
+	install -d  debian/tmp/etc/nfc
+	install -m 644 libnfc.conf.sample debian/tmp/etc/nfc/libnfc.conf
+
 %:
 	dh $@ --with autoreconf

## libnfc 1.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,14 @@
-PROJECT(libnfc C)
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
+cmake_minimum_required (VERSION 2.6)
+
+if (NOT DEFINED CMAKE_BUILD_TYPE)
+  set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
+endif ()
+
+project (libnfc C)
+
 SET(VERSION_MAJOR "1")
-SET(VERSION_MINOR "7")
-SET(VERSION_PATCH "1")
+SET(VERSION_MINOR "8")
+SET(VERSION_PATCH "0")
 
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
@@ -12,29 +18,30 @@
 
 # config.h
 IF(WIN32)
-  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config_windows.h.cmake ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
+  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config_windows.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
   SET(LIBNFC_SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/config" CACHE PATH "libnfc configuration directory")
   INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/contrib/win32)
 ELSE(WIN32)
   SET(_XOPEN_SOURCE 600)
   SET(SYSCONFDIR "/etc" CACHE PATH "System configuration directory")
-  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config_posix.h.cmake ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
-ENDIF(WIN32)
+  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config_posix.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
+ENDIF(WIN32)
+INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
 
 ADD_DEFINITIONS("-DHAVE_CONFIG_H")
 
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/include)
 
 # make it easy to locate CMake modules for finding libraries
-SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/modules/")
 
 # Options
-SET(LIBNFC_LOG ON CACHE BOOL "Enable log facility (errors, warning, info and debug messages)")
+option (LIBNFC_LOG "Enable log facility (errors, warning, info and debug messages)" ON)
 IF(LIBNFC_LOG)
   ADD_DEFINITIONS(-DLOG)
 ENDIF(LIBNFC_LOG)
 
-SET(LIBNFC_ENVVARS ON CACHE BOOL "Enable envvars facility")
+option (LIBNFC_ENVVARS "Enable envvars facility" ON)
 IF(LIBNFC_ENVVARS)
   ADD_DEFINITIONS(-DENVVARS)
 ENDIF(LIBNFC_ENVVARS)
@@ -49,10 +56,16 @@
   SET(WIN32_MODE "release")
 ENDIF(LIBNFC_DEBUG_MODE)
 
-SET(LIBNFC_CONFFILES_MODE ON CACHE BOOL "Enable configuration files")
+option (LIBNFC_CONFFILES_MODE "Enable configuration files" ON)
 IF(LIBNFC_CONFFILES_MODE)
   ADD_DEFINITIONS(-DCONFFILES)
 ENDIF(LIBNFC_CONFFILES_MODE)
+
+option (BUILD_EXAMPLES "build examples ON/OFF" ON)
+option (BUILD_UTILS "build utils ON/OFF" ON)
+
+option (BUILD_DEBPKG "build debian package ON/OFF" OFF)
+
 
 # Doxygen
 SET(builddir "${CMAKE_BINARY_DIR}")
@@ -87,12 +100,34 @@
 ADD_DEFINITIONS(-Du_int8_t=uint8_t -Du_int16_t=uint16_t)
 
 IF(MINGW)
-  # force MinGW-w64 in 32bit mode
-  SET(CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}")
-  SET(CMAKE_MODULE_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_SHARED_LINKER_FLAGS}")
-  SET(CMAKE_SHARED_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_SHARED_LINKER_FLAGS}")
-  SET(CMAKE_EXE_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_EXE_LINKER_FLAGS}")
-  SET(CMAKE_RC_FLAGS "--target=pe-i386 --output-format=coff ${CMAKE_RC_FLAGS}")
+  IF (CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
+    # force MinGW-w64 in 32bit mode
+    SET(CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}")
+    SET(CMAKE_MODULE_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_SHARED_LINKER_FLAGS}")
+    SET(CMAKE_SHARED_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_SHARED_LINKER_FLAGS}")
+    SET(CMAKE_EXE_LINKER_FLAGS "-m32 -Wl,--enable-stdcall-fixup ${CMAKE_EXE_LINKER_FLAGS}")
+    SET(CMAKE_RC_FLAGS "--target=pe-i386 --output-format=coff ${CMAKE_RC_FLAGS}")
+  ELSE(CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
+    IF(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86")
+        # force MinGW-w64 in 32bit mode
+        MESSAGE("Building 32-bit Windows DLL")
+        #SET(CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}")
+        #SET(CMAKE_MODULE_LINKER_FLAGS "--Wl,--enable-stdcall-fixup ${CMAKE_SHARED_LINKER_FLAGS}")
+        #SET(CMAKE_SHARED_LINKER_FLAGS "--Wl,--enable-stdcall-fixup ${CMAKE_SHARED_LINKER_FLAGS}")
+        #SET(CMAKE_EXE_LINKER_FLAGS "--Wl,--enable-stdcall-fixup ${CMAKE_EXE_LINKER_FLAGS}")
+        SET(CMAKE_RC_FLAGS "--target=pe-i386 --output-format=coff ${CMAKE_RC_FLAGS}")
+    ELSEIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
+        MESSAGE("Building 64-bit Windows DLL")
+        SET(CMAKE_RC_FLAGS "--target=pe-x86-64 --output-format=coff ${CMAKE_RC_FLAGS}")
+    ELSE(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86")
+        MESSAGE(FATAL_ERROR "Unknown Processor: ${CMAKE_SYSTEM_PROCESSOR}")
+    ENDIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86")
+  ENDIF(CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
+
+  FIND_PROGRAM(DLLTOOL dlltool CMAKE_FIND_ROOT_PATH_BOTH)
+  IF (NOT DLLTOOL)
+    MESSAGE(FATAL_ERROR "Could not find dlltool command")
+  ENDIF (NOT DLLTOOL)
 ENDIF(MINGW)
 
 IF(NOT WIN32)
@@ -103,25 +138,35 @@
   IF(LIBNFC_DRIVER_PN53X_USB)
     SET(PKG_REQ ${PKG_REQ} "libusb")
   ENDIF(LIBNFC_DRIVER_PN53X_USB)
-  IF(LIBNFC_DRIVER_ACR122)
+  IF(LIBNFC_DRIVER_PCSC)
     SET(PKG_REQ ${PKG_REQ} "libpcsclite")
   ENDIF(LIBNFC_DRIVER_ACR122)
+  IF(LIBNFC_DRIVER_ACR122_PCSC)
+    SET(PKG_REQ ${PKG_REQ} "libpcsclite")
+  ENDIF(LIBNFC_DRIVER_ACR122_PCSC)
   # CMake lists are separated by a semi colon, replace with colon
   STRING(REPLACE ";" "," PKG_CONFIG_REQUIRES "${PKG_REQ}")
   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libnfc.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libnfc.pc @ONLY) 
   INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libnfc.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 ENDIF(NOT WIN32)
 
-# Require PCRE for Win32
-IF (WIN32)
-  FIND_PACKAGE(PCRE REQUIRED)
-  IF(PCRE_INCLUDE_DIRS)
-    INCLUDE_DIRECTORIES(${PCRE_INCLUDE_DIRS})
-    LINK_DIRECTORIES(${PCRE_LIBRARY_DIRS})
-  ENDIF(PCRE_INCLUDE_DIRS)
-ENDIF(WIN32)
-
 INCLUDE(LibnfcDrivers)
+
+IF(UNIX AND NOT APPLE)
+    IF(I2C_REQUIRED)
+        # Inspired from http://cmake.3232098.n2.nabble.com/RFC-cmake-analog-to-AC-SEARCH-LIBS-td7585423.html
+        INCLUDE (CheckFunctionExists)
+        INCLUDE (CheckLibraryExists)
+        CHECK_FUNCTION_EXISTS (clock_gettime HAVE_CLOCK_GETTIME)
+        IF (NOT HAVE_CLOCK_GETTIME)
+            CHECK_LIBRARY_EXISTS (rt clock_gettime "" HAVE_CLOCK_GETTIME_IN_RT)
+            IF (HAVE_CLOCK_GETTIME_IN_RT)
+                SET(LIBRT_FOUND TRUE)
+                SET(LIBRT_LIBRARIES "rt")
+            ENDIF (HAVE_CLOCK_GETTIME_IN_RT)
+        ENDIF (NOT HAVE_CLOCK_GETTIME)
+    ENDIF(I2C_REQUIRED)
+ENDIF(UNIX AND NOT APPLE)
 
 IF(PCSC_INCLUDE_DIRS)
   INCLUDE_DIRECTORIES(${PCSC_INCLUDE_DIRS})
@@ -137,14 +182,22 @@
 # version.rc for Windows
 IF(WIN32)
   # Date for filling in rc file information
-  MACRO (GET_CURRENT_YEAR RESULT)
-    EXECUTE_PROCESS(COMMAND "cmd" " /C date /T" OUTPUT_VARIABLE ${RESULT})
-    STRING(REGEX REPLACE "\n" "" ${RESULT} ${${RESULT}})
-    STRING(REGEX REPLACE ".*(..)/(..)/(....).*" "\\3" ${RESULT} ${${RESULT}})
-  ENDMACRO (GET_CURRENT_YEAR)
+  IF (CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
+    MACRO (GET_CURRENT_YEAR RESULT)
+        EXECUTE_PROCESS(COMMAND "cmd" " /C date /T" OUTPUT_VARIABLE ${RESULT})
+        STRING(REGEX REPLACE "\n" "" ${RESULT} ${${RESULT}})
+        STRING(REGEX REPLACE ".*(..)/(..)/(....).*" "\\3" ${RESULT} ${${RESULT}})
+    ENDMACRO (GET_CURRENT_YEAR)
+  ELSE(CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
+    MACRO (GET_CURRENT_YEAR RESULT)
+        EXECUTE_PROCESS(COMMAND "date" "+%Y" OUTPUT_VARIABLE ${RESULT})
+        STRING(REGEX REPLACE "\n" "" ${RESULT} ${${RESULT}})
+    ENDMACRO (GET_CURRENT_YEAR)
+  ENDIF(CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
   GET_CURRENT_YEAR(CURRENT_YEAR)
   MESSAGE("Year for copyright is " ${CURRENT_YEAR})
 
+  SET(prefix ${CMAKE_INSTALL_PREFIX})
   SET(RC_COMMENT "${PACKAGE_NAME} library")
   SET(RC_INTERNAL_NAME "${PACKAGE_NAME} ${WIN32_MODE}")
   SET(RC_ORIGINAL_NAME ${PACKAGE_NAME}.dll)
@@ -154,19 +207,91 @@
 
 ADD_SUBDIRECTORY(libnfc)
 ADD_SUBDIRECTORY(include)
-ADD_SUBDIRECTORY(utils)
-ADD_SUBDIRECTORY(examples)
+
+if (BUILD_UTILS)
+  add_subdirectory (utils)
+endif ()
+
+if (BUILD_EXAMPLES)
+  add_subdirectory (examples)
+endif ()
+
+if (NOT MSVC)
+  # config script install path
+  if ( NOT DEFINED LIBNFC_CMAKE_CONFIG_DIR )
+    set ( LIBNFC_CMAKE_CONFIG_DIR lib${LIB_SUFFIX}/cmake/libnfc )
+  endif ()
+
+  set ( LIBNFC_INCLUDE_DIR ${includedir} )
+  set ( LIBNFC_INCLUDE_DIRS ${LIBNFC_INCLUDE_DIR} )
+  list ( APPEND LIBNFC_INCLUDE_DIRS ${LIBUSB_INCLUDE_DIRS} )
+  set ( LIBNFC_LIBRARY nfc )
+  set ( LIBNFC_LIBRARIES ${LIBNFC_LIBRARY} )
+  list ( APPEND LIBNFC_LIBRARIES ${LIBUSB_LIBRARIES} )
+  set ( LIBNFC_LIBRARY_DIRS ${libdir} )
+  set ( LIBNFC_ROOT_DIR ${prefix} )
+  set ( LIBNFC_VERSION_STRING ${VERSION} )
+  set ( LIBNFC_VERSION_MAJOR ${VERSION_MAJOR} )
+  set ( LIBNFC_VERSION_MINOR ${VERSION_MINOR} )
+  set ( LIBNFC_VERSION_PATCH ${VERSION_PATCH} )
+
+  set ( LIBNFC_USE_FILE ${CMAKE_INSTALL_PREFIX}/${LIBNFC_CMAKE_CONFIG_DIR}/UseLibNFC.cmake )
+
+
+          
+  if(CMAKE_VERSION VERSION_LESS 2.8.8)
+    configure_file ( cmake/LibNFCConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/LibNFCConfig.cmake @ONLY )
+    configure_file ( cmake/LibNFCConfigVersion.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/LibNFCConfigVersion.cmake @ONLY )
+  else ()
+    include(CMakePackageConfigHelpers)
+    configure_package_config_file (
+      cmake/LibNFCConfig.cmake.in
+      ${CMAKE_CURRENT_BINARY_DIR}/LibNFCConfig.cmake
+      INSTALL_DESTINATION ${LIBNFC_CMAKE_CONFIG_DIR}
+      PATH_VARS
+        LIBNFC_USE_FILE
+        LIBNFC_ROOT_DIR
+        LIBNFC_INCLUDE_DIR
+        LIBNFC_INCLUDE_DIRS
+        LIBNFC_LIBRARY_DIRS
+        NO_CHECK_REQUIRED_COMPONENTS_MACRO
+    )
+    write_basic_package_version_file (
+      LibNFCConfigVersion.cmake 
+      VERSION ${LIBNFC_VERSION_STRING} 
+      COMPATIBILITY AnyNewerVersion
+    )
+  endif ()
+   
+  install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/LibNFCConfig.cmake
+                  ${CMAKE_CURRENT_BINARY_DIR}/LibNFCConfigVersion.cmake
+                  cmake/UseLibNFC.cmake
+            DESTINATION ${LIBNFC_CMAKE_CONFIG_DIR}
+          )
+   
+endif ()
 
 # Binary Package
 IF(WIN32)
   SET(CPACK_GENERATOR "ZIP")
 ELSE(WIN32)
   SET(CPACK_GENERATOR "TBZ2")
+  IF(BUILD_DEBPKG)
+    SET(CPACK_GENERATOR "DEB")
+  ENDIF(BUILD_DEBPKG)
 ENDIF(WIN32)
 
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Near Field Communication (NFC) library")
 SET(CPACK_PACKAGE_VENDOR "Roel Verdult")
-SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
+SET(CPACK_PACKAGE_CONTACT "Roel Verdult <roel@libnfc.org>")
+
+#Readme file
+IF(WIN32)
+  SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README-Windows.md")
+ELSE(WIN32)
+  SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
+ENDIF(WIN32)
+
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
 SET(CPACK_PACKAGE_INSTALL_DIRECTORY "libnfc")
 SET(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,9 @@
   nfc-mfsetuid
   nfc-poll
   nfc-relay
+  pn53x-diagnose
+  pn53x-sam
+  pn53x-tamashell
 )
 
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../libnfc)

=== libnfc/CMakeLists.txt ===
--- 
+++ 
@@ -47,16 +47,6 @@
 
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/buses)
 
-IF(WIN32)
-  # Windows now requires regex, so we utilize PCRE
-  # since Windows doesn't get the benefit of finding in CMake
-  # it has to be added manually
-  IF(PCRE_FOUND)
-    INCLUDE_DIRECTORIES(${PCRE_INCLUDE_DIRS})
-    LINK_DIRECTORIES(${PCRE_LIBRARY_DIRS})
-  ENDIF(PCRE_FOUND)
-ENDIF(WIN32)
-
 IF(PCSC_FOUND)
   INCLUDE_DIRECTORIES(${PCSC_INCLUDE_DIRS})
   LINK_DIRECTORIES(${PCSC_LIBRARY_DIRS})
@@ -89,18 +79,19 @@
   TARGET_LINK_LIBRARIES(nfc ${LIBUSB_LIBRARIES})
 ENDIF(LIBUSB_FOUND)
 
-SET_TARGET_PROPERTIES(nfc PROPERTIES SOVERSION 0)
+IF(LIBRT_FOUND)
+  TARGET_LINK_LIBRARIES(nfc ${LIBRT_LIBRARIES})
+ENDIF(LIBRT_FOUND)
+
+SET_TARGET_PROPERTIES(nfc PROPERTIES SOVERSION 6 VERSION 6.0.0)
 
 IF(WIN32)
   # Libraries that are windows specific
   TARGET_LINK_LIBRARIES(nfc wsock32)
-  IF(PCRE_FOUND)
-    TARGET_LINK_LIBRARIES(nfc ${PCRE_LIBRARIES})
-  ENDIF(PCRE_FOUND)
 
   ADD_CUSTOM_COMMAND(
     OUTPUT libnfc.lib
-    COMMAND dlltool -d ${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32/nfc.def -l ${CMAKE_CURRENT_BINARY_DIR}/libnfc.lib ${CMAKE_CURRENT_BINARY_DIR}/libnfc.dll
+    COMMAND ${DLLTOOL} -d ${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32/nfc.def -l ${CMAKE_CURRENT_BINARY_DIR}/libnfc.lib ${CMAKE_CURRENT_BINARY_DIR}/libnfc.dll
     DEPENDS nfc ${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32/nfc.def
   )
   ADD_CUSTOM_TARGET(win32lib ALL DEPENDS libnfc.lib)

=== utils/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,7 @@
 SET(UTILS-SOURCES 
+  nfc-barcode
   nfc-emulate-forum-tag4
+  nfc-jewel
   nfc-list
   nfc-mfclassic
   nfc-mfultralight
@@ -25,6 +27,10 @@
     CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/../contrib/win32/version.rc.in ${CMAKE_CURRENT_BINARY_DIR}/../windows/${source}.rc @ONLY)
     LIST(APPEND TARGETS ${CMAKE_CURRENT_BINARY_DIR}/../windows/${source}.rc)
   ENDIF(WIN32)
+
+  IF(${source} MATCHES "nfc-jewel")
+    LIST(APPEND TARGETS jewel)
+  ENDIF(${source} MATCHES "nfc-jewel")
 
   IF((${source} MATCHES "nfc-mfultralight") OR (${source} MATCHES "nfc-mfclassic"))
     LIST(APPEND TARGETS mifare)

=== debian/changelog ===
libnfc (1.8.0-3.1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:46:13 +0200

libnfc (1.8.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Release to unstable. Includes UsrMerge DEP17 P7 mitigation
    (Closes: #1057358)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 10 Dec 2023 12:46:00 +0100

libnfc (1.8.0-3) experimental; urgency=medium

  * Non-maintainer upload.

  [ Debian Janitor ]
  * Drop unnecessary dependency on dh-autoreconf.
  * Fix day-of-week for changelog entries 1.7.0-0, 1.7.0~rc1-0, 1.5.0pre1.4-0,
    1.5.0pre1.1-0, 1.5.0-0, 1.4.2-0, 1.3.3-0, 1.2.1-3, 1.2.1-2, 1.2.1-1.
  * Update standards version to 4.6.2, no changes needed.

  [ Utkarsh Gupta ]
  * Install 93-pn53x.rules into /usr, with protective diversion.
    (DEP17 P7 M10)

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 24 Nov 2023 15:12:37 +0000

libnfc (1.8.0-2) unstable; urgency=medium

  * new build to do a source only upload

 -- Ludovic Rousseau <rousseau@debian.org>  Sun, 16 Aug 2020 12:11:21 +0200

libnfc (1.8.0-1) unstable; urgency=medium

  * New upstream released.
  * Fix "New upstream version: 1.8.0" (Closes: #961229)
  * d/libnfc5.install: contrib/udev/42-pn53x.rules renamed 93-pn53x.rules
  * d/control: remove libnfc5-dbg package
    libnfc source: debian-control-has-obsolete-dbg-package libnfc5-dbg
  * d/control: add Rules-Requires-Root: no
    libnfc source: silent-on-rules-requiring-root
  * d/changelog: remove trailing-whitespace
  * d/rules: remove trailing-whitespace
  * d/copyright: use https for copyright format
  * d/control: use priority optional instead of (deprecated) extra
  * d/control: use debhelper compat level 13
  * d/control: use libnfc6 instead of libnfc5
  * d/p/fix_timeout_message_with_ACR122U.patch: refresh
  * Include new binaries nfc-jewel & nfc-barcode
  * d/control: remove now useless Build-Depends: dh-autoreconf
  * d/libnfc6.symbols: add new symbols
  * d/rules: use DEB_BUILD_MAINT_OPTIONS instead of DEB_BUILD_OPTIONS
  * d/libnfc6.symbols: add missing * Build-Depends-Package:libnfc-dev
  * d/rules: use DEB_BUILD_MAINT_OPTIONS = hardening=+all
  * d/*.install: remove debian/tmp/ from filenames
  * d/control: Standards-Version: 3.9.6 -> 4.5.0. No more change needed.
  * d/rules: strip every packages

 -- Ludovic Rousseau <rousseau@debian.org>  Sun, 09 Aug 2020 16:58:37 +0200

=== debian/control ===
Source: libnfc
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Uploaders: Ludovic Rousseau <rousseau@debian.org>
Build-Depends: debhelper-compat (= 13), libtool, pkg-config, libusb-dev
Standards-Version: 4.6.2
Homepage: http://www.nfc-tools.org/
Vcs-Git: https://salsa.debian.org/debian/libnfc.git
Vcs-Browser: https://salsa.debian.org/debian/libnfc
Rules-Requires-Root: no

Package: libnfc6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libnfc5
Breaks: libnfc5
Description: Near Field Communication (NFC) library
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 This package contains the runtime library files needed to run software
 using libnfc.

Package: libnfc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libnfc6 (= ${binary:Version}), libusb-dev
Description: Near Field Communication (NFC) library (development files)
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 This package contains the header and development files needed to build
 programs and packages using libnfc.

Package: libnfc-bin
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libnfc6 (>= ${binary:Version})
Description: Near Field Communication (NFC) binaries
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 This package contains some utils that come along with libnfc, for
 development or debugging purposes (including nfc-list, nfc-mfclassic,
 nfc-mfultralight, etc).

Package: libnfc-examples
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libnfc6 (>= ${binary:Version})
Description: Near Field Communication (NFC) examples
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 Some examples are provided with libnfc for debugging and/or
 educational purposes (nfc-anticol, nfc-emulate, etc.).

Package: libnfc-pn53x-examples
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libnfc6 (>= ${binary:Version})
Description: Near Field Communication (NFC) examples for PN53x chips only
 libnfc is a library for Near Field Communication. It abstracts the
 low-level details of communicating with the devices away behind an
 easy-to-use high-level API.
 It supports most hardware based on the NXP PN531, PN532 or PN533
 controller chips.
 .
 Some PN53x-only examples are provided with libnfc for debugging
 and/or educational purposes (pn53x-sam, pn53x-tamashell, etc.).

=== debian/watch ===
version=3
opts=uversionmangle=s/[-+.](beta|alpha|rc)/~$1/ \
https://github.com/nfc-tools/libnfc/tags (?:.*/)?libnfc-(\d.*)\.tar\.gz
